#<profile4xi profile = "11"/>
# -------------------------------------------------------------------------------------------------
#<program4xi program = "test_locks_mp_xi4.py">
#<verify4xi verification = "10" target = "lock4xi.py"/>
#<contextualize4xi context = "process4xi.py; queue4xi.py; pipe4xi.py; manager4xi.py; pool24xi.py;
#                             value4xi.py; valuefunction4xi.py; 
#                             arrayfunction4xi.py; basemanager4xi.py; baseproxy4xi.py; 
#                             active_children4xi.py; condition4xi.py; semaphore4xi.py;
#                             rlock4xi.py; event4xi.py"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            
            'test4', 
            'test2',
            'test1',
              
            'test_sharedvalues4xi',
            'test_sharedvalues2xi',            
            'test_sharedvalues',            
            'sharedvalues_func4xi',
            'sharedvalues_func2xi',            
            'sharedvalues_func',            
    
            'test_event4xi',
            'test_event2xi',            
            'test_event',            
            'event_func4xi',
            'event_func2xi',            
            'event_func',            
           
            'test_join_timeout4xi',
            'test_join_timeout2xi',            
            'test_join_timeout',            
            'join_timeout_func4xi', 
            'join_timeout_func2xi',             
            'join_timeout_func', 
                                              
            'test_semaphore4xi',
            'test_semaphore2xi',
            'test_semaphore',
            'semaphore_func4xi',             
            'semaphore_func2xi',            
            'semaphore_func', 
            
            'test_condition4xi',            
            'test_condition2xi',             
            'test_condition',
            'condition_func4xi',             
            'condition_func2xi',             
            'condition_func', 
            
            'test_queue4xi',            
            'test_queue2xi',
            'test_queue',  
            'queue_func4xi',
            'queue_func2xi', 
            'queue_func',
            
            'test_value4xi',              
            'test_value2xi',  
            'test_value',
            'value_func4xi',                
            'value_func2xi',                                                                          
            'value_func',
            
            'print_trace4xi',
            'set_trace4xi',            
            'deny_trace4xi']
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # most-common ones
    import time
    import random
    import operator         
except:
    pass
try:                 # rare ones
    from ctypes import Structure, c_double
    import gc                                                            # garbage collector
    import queue                                                         # NOT Queue as in the original
    from queue import Empty
 
except:
    pass 
try:                 # imported-as ones 
    pass           
except:
    pass            
#"
#/>


# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    import multiprocessing
    from multiprocessing import Process
    from multiprocessing import Queue
    from multiprocessing import Pipe
    from multiprocessing import Lock
    from multiprocessing import Manager
    from multiprocessing import Pool
    from multiprocessing import current_process
    from multiprocessing import freeze_support
    from multiprocessing.sharedctypes import Value, Array
    from multiprocessing.managers import BaseManager, BaseProxy
except:
    pass
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from process2xi import Process2Xi
from queue2xi import Queue2Xi
from pipe2xi import Pipe2Xi
from lock2xi import Lock2Xi
from manager2xi import Manager2Xi
from pool2xi import Pool2Xi
from current_process2xi import current_process2xi
from value2xi import Value2Xi
from valuefunction2xi import ValueFunction2Xi
from arrayfunction2xi import ArrayFunction2Xi
from basemanager2xi import BaseManager2Xi
from baseproxy2xi import BaseProxy2Xi
from active_children2xi import active_children2xi
from info2xi import info2xi
from debug_info2xi import debug_info2xi
from condition2xi import Condition2Xi
from semaphore2xi import Semaphore2Xi
from rlock2xi import RLock2Xi
from event2xi import Event2Xi


from active_children4xi import active_children4xi
from arrayfunction4xi import ArrayFunction4Xi

# from current_process4xi import current_process4xi <-- to be solved!

from basemanager4xi import BaseManager4Xi
from baseproxy4xi import BaseProxy4Xi

from condition4xi import Condition4Xi

from debug_info4xi import debug_info4xi

from event4xi import Event4Xi

from info4xi import info4xi

from lock4xi import Lock4Xi

from manager4xi import Manager4Xi

from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi 
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi

from pipe4xi import Pipe4Xi
from pool4xi import Pool4Xi
from print4xi import Print4Xi
from process4xi import Process4Xi

from queue4xi import Queue4Xi

from rlock4xi import RLock4Xi

from semaphore4xi import Semaphore4Xi

from time4xi import time4xi

from value4xi import Value4Xi
from valuefunction4xi import ValueFunction4Xi      

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {'Manager4Xi': 'ACK4TRACE',                           
                'SyncManager4Xi': 'NACK4TRACE',                           
                'Process4Xi': 'NACK4TRACE',                               
                'Client4Xi': 'NACK4TRACE',                                
                '_MainProcess4Xi': 'NACK4TRACE',                          
                'get_preparation_data4xi': 'NACK4TRACE',                  
                'Listener4Xi': 'NACK4TRACE',                              
                'Lock4Xi':'NACK4TRACE',                                   
                'MainProcess4Xi': 'NACK4TRACE',                       
                'Pipe4Xi': 'NACK4TRACE',                                
                'dump': 'NACK4TRACE',                                      
                'duplicate': 'NACK4TRACE',                            
                'Popen4Xi': 'NACK4TRACE',                              
                'is_forking': 'NACK4TRACE',                          
                'freeze_support': 'NACK4TRACE',                  
                'get_command_line': 'NACK4TRACE',              
                'main': 'NACK4TRACE',                                      
                'reduce_connection': 'NACK4TRACE',            
                'Queue4Xi': 'NACK4TRACE',                              
                'SemLock4Xi': 'NACK4TRACE',                            
                'Server4Xi': 'NACK4TRACE',
                'PipeListener4Xi': 'NACK4TRACE',
                'Listener4Xi': 'NACK4TRACE'}      
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
#</function4xi>       
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   printing trace
#">                    
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-test-locks4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Locks in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Locks in Multiprocessing.</rdfs:comment>\n'}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-test-locks4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Locks in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Locks in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n'}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-test-locks4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Locks in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Locks in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n'}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
              
# =================================================================================================
# [1] TEST_VALUE with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "value_func" usage = "
#   test_value
#"> 
# -------------------------------------------------------------------------------------------------
def value_func(running, mutex):
    random.seed()
    time.sleep(random.random()*4)

    mutex.acquire()
    print ('\n\t\t\t' + str(multiprocessing.current_process()) + ' has finished')
    running.value -= 1
    mutex.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_value" usage = "
#   testing Value
#"> 
# -------------------------------------------------------------------------------------------------
def test_value():
    TASKS = 10
    running = multiprocessing.Value('i', TASKS)
    mutex = multiprocessing.Lock()

    for i in range(TASKS):
        p = multiprocessing.Process(target=value_func, args=(running, mutex))
        p.start() 

    while running.value > 0:
        time.sleep(0.08)
        mutex.acquire()
        print (running.value, sys.stdout.flush())
        mutex.release()

    print ('No more running processes')
#</function4xi>

# =================================================================================================
# [2] TEST_VALUE with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "value_func2xi" usage = "
#   test_value2xi
#"> 
# -------------------------------------------------------------------------------------------------
def value_func2xi(running, mutex):
    random.seed()
    time.sleep(random.random()*4)

    mutex.acquire()
    print ('\n\t\t\t' + str(current_process2xi()) + ' has finished')
    running.value -= 1
    mutex.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_value2xi" usage = "
#   testing ValueFunction2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_value2xi():
    TASKS2xi = 10
    running2xi = ValueFunction2Xi('i', TASKS2xi)
    mutex2xi = Lock2Xi()

    for i in range(TASKS2xi):
        p2xi = Process2Xi(target=value_func2xi, args=(running2xi, mutex2xi))
        p2xi.start()

    while running2xi.value > 0:
        time.sleep(0.08)
        mutex2xi.acquire()
        print (running2xi.value, sys.stdout.flush())
        mutex2xi.release()

    print ('test_value2xi: No more running processes')    
#</function4xi>


# =================================================================================================
# [4] TEST_VALUE with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "value_func4xi" usage = "
#   test_value4xi
#"> 
# -------------------------------------------------------------------------------------------------
def value_func4xi(running, mutex):
    random.seed()
    time.sleep(random.random()*4)

    mutex.acquire()
    print ('\n\t\t\t' + str(current_process4xi()) + ' has finished')
    running.value -= 1
    mutex.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_value4xi" usage = "
#   testing ValueFunction4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_value4xi():
    TASKS4xi = 10
    running4xi = ValueFunction4Xi('i', TASKS4xi)
    mutex4xi = Lock4Xi()

    for i in range(TASKS4xi):
        p4xi = Process4Xi(target=value_func4xi, args=(running4xi, mutex4xi))
        p4xi.start()

    while running4xi.value > 0:
        time.sleep(0.08)
        mutex4xi.acquire()
        print (running4xi.value, sys.stdout.flush())
        mutex4xi.release()

    print ('test_value4xi: No more running processes')    
#</function4xi>
    

    
# =================================================================================================
# [1] TEST_QUEUE with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "queue_func" usage = "
#   test_queue
#"> 
# -------------------------------------------------------------------------------------------------
def queue_func(queue):
    for i in range(30):
        time.sleep(0.5 * random.random())
        queue.put(i*i)
    queue.put('STOP')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_queue" usage = "
#   testing multiprocessing.Queue
#"> 
# -------------------------------------------------------------------------------------------------
def test_queue():
    q = multiprocessing.Queue()

    p = multiprocessing.Process(target=queue_func, args=(q,))
    p.start()

    o = None
    while o != 'STOP':
        try:
            o = q.get(timeout=0.3)
            print (o, sys.stdout.flush())
        except Empty:
            print ('TIMEOUT')

    print ()
#</function4xi>
    
# =================================================================================================
# [2] TEST_QUEUE with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "queue_func2xi" usage = "
#   test_queue2xi
#"> 
# -------------------------------------------------------------------------------------------------
def queue_func2xi(queue2xi):
    for i in range(30):
        time.sleep(0.5 * random.random())
        queue2xi.put(i*i)
    queue2xi.put('STOP')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_queue2xi" usage = "
#   testing Queue2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_queue2xi():
    q2xi = Queue2Xi()

    p2xi = Process2Xi(target=queue_func2xi, args=(q2xi,))
    p2xi.start()

    o2xi = None
    while o2xi != 'STOP':
        try:
            o2xi = q2xi.get(timeout=0.3)
            print (o2xi, sys.stdout.flush())
        except Empty:
            print ('test_queue2xi: TIMEOUT')

    print ()    
#</function4xi>
    
# =================================================================================================
# [4] TEST_QUEUE with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "queue_func4xi" usage = "
#   test_queue4xi
#"> 
# -------------------------------------------------------------------------------------------------
def queue_func4xi(queue4xi):
    for i in range(30):
        time.sleep(0.5 * random.random())
        queue4xi.put(i*i)
    queue4xi.put('STOP')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_queue4xi" usage = "
#   testing Queue4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_queue4xi():
    q4xi = Queue4Xi()

    p4xi = Process4Xi(target=queue_func4xi, args=(q4xi,))
    p4xi.start()

    o4xi = None
    while o4xi != 'STOP':
        try:
            o4xi = q4xi.get(timeout=0.3)
            print (o4xi, sys.stdout.flush())
        except Empty:
            print ('test_queue4xi: TIMEOUT')

    print ()    
#</function4xi>
        
# =================================================================================================
# [1] TEST_CONDITION with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "condition_func" usage = "
#   test_condition
#"> 
# -------------------------------------------------------------------------------------------------
def condition_func(cond):
    cond.acquire()
    print ('\t' + str(cond))
    time.sleep(2)
    print ('\tchild is notifying')
    print ('\t' + str(cond))
    cond.notify()
    cond.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_condition" usage = "
#   testing multiprocessing.Condition
#"> 
# -------------------------------------------------------------------------------------------------    
def test_condition():
    cond = multiprocessing.Condition()

    p = multiprocessing.Process(target=condition_func, args=(cond,))
    print (cond)

    cond.acquire()
    print (cond)
    cond.acquire()
    print (cond)

    p.start()

    print ('main is waiting')
    cond.wait()
    print ('main has woken up')

    print (cond)
    cond.release()
    print (cond)
    cond.release()

    p.join()
    print (cond)
#</function4xi>

# =================================================================================================
# [2] TEST_CONDITION with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "condition_func2xi" usage = "
#   test_condition2xi
#"> 
# -------------------------------------------------------------------------------------------------
def condition_func2xi(cond2xi):
    cond2xi.acquire()
    print ('\t' + str(cond2xi))
    time.sleep(2)
    print ('\tchild is notifying')
    print ('\t' + str(cond2xi))
    cond2xi.notify()
    cond2xi.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_condition2xi" usage = "
#   testing Condition2Xi
#"> 
# -------------------------------------------------------------------------------------------------    
def test_condition2xi():
    cond2xi = Condition2Xi()

    p2xi = Process2Xi(target=condition_func2xi, args=(cond2xi,))
    print ('test_condition2xi/cond2xi = ', cond2xi)

    cond2xi.acquire()
    print ('test_condition2xi/cond2xi = ', cond2xi)
    cond2xi.acquire()
    print ('test_condition2xi/cond2xi = ', cond2xi)

    p2xi.start()

    print ('test_condition2xi: ', 'main is waiting')
    cond2xi.wait()
    print ('test_condition2xi: ', 'main has woken up')

    print ('test_condition2xi/cond2xi = ', cond2xi)
    cond2xi.release()
    print ('test_condition2xi/cond2xi = ', cond2xi)
    cond2xi.release()

    p2xi.join()
    print ('test_condition2xi/cond2xi = ', cond2xi)    
#</function4xi>

# =================================================================================================
# [4] TEST_CONDITION with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "condition_func4xi" usage = "
#   test_condition4xi
#"> 
# -------------------------------------------------------------------------------------------------
def condition_func4xi(cond4xi):
    cond4xi.acquire()
    print ('\t' + str(cond4xi))
    time.sleep(2)
    print ('\tchild is notifying')
    print ('\t' + str(cond4xi))
    cond4xi.notify()
    cond4xi.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_condition4xi" usage = "
#   testing Condition4Xi
#"> 
# -------------------------------------------------------------------------------------------------    
def test_condition4xi():
    cond4xi = Condition4Xi()

    p4xi = Process4Xi(target=condition_func4xi, args=(cond4xi,))
    print ('test_condition4xi/cond4xi = ', cond4xi)

    cond4xi.acquire()
    print ('test_condition4xi/cond4xi = ', cond4xi)
    cond4xi.acquire()
    print ('test_condition4xi/cond4xi = ', cond4xi)

    p4xi.start()

    print ('test_condition4xi: ', 'main is waiting')
    cond4xi.wait()
    print ('test_condition4xi: ', 'main has woken up')

    print ('test_condition4xi/cond4xi = ', cond4xi)
    cond4xi.release()
    print ('test_condition4xi/cond4xi = ', cond4xi)
    cond4xi.release()

    p4xi.join()
    print ('test_condition4xi/cond4xi = ', cond4xi)    
#</function4xi>
        
# =================================================================================================
# [1] TEST_SEMAPHORE with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "semaphore_func" usage = "
#   test_semaphore
#"> 
# -------------------------------------------------------------------------------------------------
def semaphore_func(sema, mutex, running):
    sema.acquire()

    mutex.acquire()
    running.value += 1
    print (running.value, 'tasks are running')
    mutex.release()

    random.seed()
    time.sleep(random.random()*2)

    mutex.acquire()
    running.value -= 1
    print ('%s has finished' % multiprocessing.current_process())
    mutex.release()

    sema.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_semaphore" usage = "
#   testing multiprocessing.Semaphore
#"> 
# -------------------------------------------------------------------------------------------------
def test_semaphore():
    sema = multiprocessing.Semaphore(3)
    mutex = multiprocessing.RLock()
    running = multiprocessing.Value('i', 0)

    processes = [
        multiprocessing.Process(target=semaphore_func,
                                args=(sema, mutex, running))
        for i in range(10)
        ]

    for p in processes:
        p.start()

    for p in processes:
        p.join()
#</function4xi>

# =================================================================================================
# [2] TEST_SEMAPHORE with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "semaphore_func2xi" usage = "
#   test_semaphore2xi
#"> 
# -------------------------------------------------------------------------------------------------
def semaphore_func2xi(sema2xi, mutex2xi, running2xi):
    
    sema2xi.acquire()
    mutex2xi.acquire()
    
    running2xi.value += 1
    print (running2xi.value, 'tasks are running')
    mutex2xi.release()

    random.seed()
    time.sleep(random.random()*2)

    mutex2xi.acquire()
    running2xi.value -= 1
    print ('%s has finished' % current_process2xi())

    mutex2xi.release()
    sema2xi.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_semaphore2xi" usage = "
#   testing Semaphore2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_semaphore2xi():

    sema2xi = Semaphore2Xi(3)
    mutex2xi = RLock2Xi()
    running2xi = ValueFunction2Xi('i', 0)

    processes = [
        Process2Xi(target=semaphore_func2xi, args=(sema2xi, mutex2xi, running2xi))
        for i in range(10)
        ]

    for p2xi in processes:
        p2xi.start()

    for p2xi in processes:
        p2xi.join()        
#</function4xi>

# =================================================================================================
# [4] TEST_SEMAPHORE with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "semaphore_func4xi" usage = "
#   test_semaphore4xi
#"> 
# -------------------------------------------------------------------------------------------------
def semaphore_func4xi(sema4xi, mutex4xi, running4xi):
    
    sema4xi.acquire()
    mutex4xi.acquire()
    
    running4xi.value += 1
    print (running4xi.value, 'tasks are running')
    mutex4xi.release()

    random.seed()
    time.sleep(random.random()*2)

    mutex4xi.acquire()
    running4xi.value -= 1
    print ('%s has finished' % current_process4xi())

    mutex4xi.release()
    sema4xi.release()
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_semaphore4xi" usage = "
#   testing Semaphore4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_semaphore4xi():

    sema4xi = Semaphore4Xi(3)
    mutex4xi = RLock4Xi()
    running4xi = ValueFunction4Xi('i', 0)

    processes = [
        Process4Xi(target=semaphore_func4xi, args=(sema4xi, mutex4xi, running4xi))
        for i in range(10)
        ]

    for p4xi in processes:
        p4xi.start()

    for p4xi in processes:
        p4xi.join()        
#</function4xi>
                
# =================================================================================================
# [1] TEST_JOIN_TIMEOUT with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "join_timeout_func" usage = "
#   test_join_timeout
#"> 
# -------------------------------------------------------------------------------------------------
def join_timeout_func():
    print ('\tchild sleeping')
    time.sleep(5.5)
    print ('\n\tchild terminating')
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_join_timeout" usage = "
#   testing join method of Process
#"> 
# -------------------------------------------------------------------------------------------------
def test_join_timeout():
    p = multiprocessing.Process(target=join_timeout_func)
    p.start()

    print ('waiting for process to finish')

    while 1:
        p.join(timeout=1)
        if not p.is_alive():
            break
        print ('.',sys.stdout.flush())
#</function4xi>

# =================================================================================================
# [2] TEST_JOIN_TIMEOUT with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "join_timeout_func2xi" usage = "
#   test_join_timeout2xi
#"> 
# -------------------------------------------------------------------------------------------------
def join_timeout_func2xi():
    print ('\tchild sleeping in join_timeout_func2xi')
    time.sleep(5.5)
    print ('\n\tchild terminating in join_timeout_func2xi')
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_join_timeout2xi" usage = "
#   testing join of Process2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_join_timeout2xi():
    p2xi = Process2Xi(target=join_timeout_func2xi)
    p2xi.start()

    print ('test_join_timeout2xi: waiting for process to finish')

    while 1:
        p2xi.join(timeout=1)
        if not p2xi.is_alive():
            break
        print ('.',sys.stdout.flush())
#</function4xi>

# =================================================================================================
# [4] TEST_JOIN_TIMEOUT with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "join_timeout_func4xi" usage = "
#   test_join_timeout4xi
#"> 
# -------------------------------------------------------------------------------------------------
def join_timeout_func4xi():
    print ('\tchild sleeping in join_timeout_func4xi')
    time.sleep(5.5)
    print ('\n\tchild terminating in join_timeout_func4xi')
#</function4xi>
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_join_timeout4xi" usage = "
#   testing join of Process4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_join_timeout4xi():
    p4xi = Process4Xi(target=join_timeout_func4xi)
    p4xi.start()

    print ('test_join_timeout4xi: waiting for process to finish')

    while 1:
        p4xi.join(timeout=1)
        if not p4xi.is_alive():
            break
        print ('.',sys.stdout.flush())
#</function4xi>
                                
# =================================================================================================
# [1] TEST_EVENT with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "event_func" usage = "
#   test_event
#"> 
# -------------------------------------------------------------------------------------------------
def event_func(event):
    print ('\t%r is waiting' % multiprocessing.current_process())
    event.wait()
    print ('\t%r has woken up' % multiprocessing.current_process())
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_event" usage = "
#   testing multiprocessing.Event
#"> 
# -------------------------------------------------------------------------------------------------
def test_event():
    event = multiprocessing.Event()

    processes = [multiprocessing.Process(target=event_func, args=(event,))
                 for i in range(5)]

    for p in processes:
        p.start()

    print ('main is sleeping')
    time.sleep(2)

    print ('main is setting event')
    event.set()

    for p in processes:
        p.join()
#</function4xi>

# =================================================================================================
# [2] TEST_EVENT with dragonized multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "event_func2xi" usage = "
#   test_event2xi
#"> 
# -------------------------------------------------------------------------------------------------
def event_func2xi(event2xi):
    print ('\t%r is waiting' % current_process2xi())
    event2xi.wait()
    print ('\t%r has woken up' % current_process2xi())
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_event2xi" usage = "
#   testing Event2Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_event2xi():

    event2xi = Event2Xi()
    processes2xi = [Process2Xi(target=event_func2xi, args=(event2xi,))
                 for i in range(5)]

    for p2xi in processes2xi:
        p2xi.start()

    print ('test_event2xi: main is sleeping')
    time.sleep(2)

    print ('test_event2xi: main is setting event')
    event2xi.set()

    for p2xi in processes2xi:
        p2xi.join()        
#</function4xi>

# =================================================================================================
# [4] TEST_EVENT with dragonized multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "event_func4xi" usage = "
#   test_event4xi
#"> 
# -------------------------------------------------------------------------------------------------
def event_func4xi(event4xi):
    print ('\t%r is waiting' % current_process4xi())
    event4xi.wait()
    print ('\t%r has woken up' % current_process4xi())
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_event4xi" usage = "
#   testing Event4Xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_event4xi():

    event4xi = Event4Xi()
    processes4xi = [Process4Xi(target=event_func4xi, args=(event4xi,))
                 for i in range(5)]

    for p4xi in processes4xi:
        p4xi.start()

    print ('test_event4xi: main is sleeping')
    time.sleep(2)

    print ('test_event4xi: main is setting event')
    event4xi.set()

    for p4xi in processes4xi:
        p4xi.join()        
#</function4xi>
                
# =================================================================================================
# [1] TEST_SHAREDVALUES with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sharedvalues_func" usage = "
#   test_sharedvalues
#"> 
# -------------------------------------------------------------------------------------------------
def sharedvalues_func(values, arrays, shared_values, shared_arrays):
    for i in range(len(values)):
        v = values[i][1]
        sv = shared_values[i].value
        assert v == sv

    for i in range(len(values)):
        a = arrays[i][1]
        sa = list(shared_arrays[i][:])
        # assert a == sa <--- assertion error

    print ('Tests passed')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_sharedvalues" usage = "
#   testing sharedvalues
#"> 
# -------------------------------------------------------------------------------------------------
def test_sharedvalues():
    values = [
        ('i', 10),
        ('h', -2),
        ('d', 1.25)
        ]
    arrays = [
        ('i', range(100)),
        ('d', [0.25 * i for i in range(100)]),
        ('H', range(1000))
        ]

    shared_values = [multiprocessing.Value(id, v) for id, v in values]
    shared_arrays = [multiprocessing.Array(id, a) for id, a in arrays]

    p = multiprocessing.Process(
        target=sharedvalues_func,
        args=(values, arrays, shared_values, shared_arrays)
        )
    p.start()
    p.join()

#   assert p.exitcode == 0
#</function4xi>

# =================================================================================================
# [2] TEST_SHAREDVALUES with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sharedvalues_func2xi" usage = "
#   test_sharedvalues2xi
#"> 
# -------------------------------------------------------------------------------------------------
def sharedvalues_func2xi(values2xi, arrays2xi, shared_values2xi, shared_arrays2xi):
    for i in range(len(values2xi)):
        v2xi = values2xi[i][1]
        sv2xi = shared_values2xi[i].value
        assert v2xi == sv2xi

    for i in range(len(values2xi)):
        a2xi = arrays2xi[i][1]
        sa2xi = list(shared_arrays2xi[i][:])

    print ('sharedvalues_func2xi: Tests passed')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_sharedvalues2xi" usage = "
#   testing sharedvalues
#"> 
# -------------------------------------------------------------------------------------------------
def test_sharedvalues2xi():
    values2xi = [
        ('i', 10),
        ('h', -2),
        ('d', 1.25)
        ]
    arrays2xi = [
        ('i', range(100)),
        ('d', [0.25 * i for i in range(100)]),
        ('H', range(1000))
        ]

    shared_values2xi = [ValueFunction2Xi(id, v) for id, v in values2xi]
    shared_arrays2xi = [ArrayFunction2Xi(id, a) for id, a in arrays2xi]

    p2xi = Process2Xi(
        target=sharedvalues_func2xi,
        args=(values2xi, arrays2xi, shared_values2xi, shared_arrays2xi)
        )
    p2xi.start()
    p2xi.join()
#</function4xi>


# =================================================================================================
# [4] TEST_SHAREDVALUES with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "sharedvalues_func4xi" usage = "
#   test_sharedvalues4xi
#"> 
# -------------------------------------------------------------------------------------------------
def sharedvalues_func4xi(values4xi, arrays4xi, shared_values4xi, shared_arrays4xi):
    for i in range(len(values4xi)):
        v4xi = values4xi[i][1]
        sv4xi = shared_values4xi[i].value
        assert v4xi == sv4xi

    for i in range(len(values4xi)):
        a4xi = arrays4xi[i][1]
        sa4xi = list(shared_arrays4xi[i][:])

    print ('sharedvalues_func4xi: Tests passed')
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test_sharedvalues4xi" usage = "
#   testing sharedvalues4xi
#"> 
# -------------------------------------------------------------------------------------------------
def test_sharedvalues4xi():
    values4xi = [
        ('i', 10),
        ('h', -2),
        ('d', 1.25)
        ]
    arrays4xi = [
        ('i', range(100)),
        ('d', [0.25 * i for i in range(100)]),
        ('H', range(1000))
        ]

    shared_values4xi = [ValueFunction4Xi(id, v) for id, v in values4xi]
    shared_arrays4xi = [ArrayFunction4Xi(id, a) for id, a in arrays4xi]

    p4xi = Process4Xi(
        target=sharedvalues_func4xi,
        args=(values4xi, arrays4xi, shared_values4xi, shared_arrays4xi)
        )
    p4xi.start()
    p4xi.join()
#</function4xi>

# =================================================================================================
# [1] TEST 1 with standard multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test1 function" usage = "
#   tests with standard multiprocessing package
#"> 
# -------------------------------------------------------------------------------------------------
def test1(namespace=multiprocessing):
    global multiprocessing

    multiprocessing = namespace
    # ---------------------------------------------------------------------------------------------
    # test all functions
    # ---------------------------------------------------------------------------------------------
    for func in [ test_value, test_queue, test_condition,
                  test_semaphore, test_join_timeout, test_event,
                  test_sharedvalues ]:

        print ('\n\t######## %s\n' % func.__name__)
        func()
    # ---------------------------------------------------------------------------------------------
    # Notes: you can test one function at a time in both phases as follows:
    # ---------------------------------------------------------------------------------------------
    #     for func in [ test_sharedvalues ]: #<--- here
    #  
    #         print ('\n\t######## %s\n' % func.__name__)
    #         func()

    ignorei = multiprocessing.active_children()      # cleanup any old processes
    if hasattr(multiprocessing, '_debug_info'):
        info = multiprocessing._debug_info()
        if info:
            print (info)
            # raise ValueError, 'there should be no positive refcounts left' <--- syntax error
#</function4xi>

# =================================================================================================
# [2] TEST 2 with dragon2xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test2 function" usage = "
#   tests with dragon2xi multiprocessing package
#"> 
# -------------------------------------------------------------------------------------------------
def test2(namespace=multiprocessing): #<--- this is demanding; propably the same name space
    global multiprocessing

    multiprocessing = namespace
    # ---------------------------------------------------------------------------------------------
    # test all functions
    # ---------------------------------------------------------------------------------------------
    for func2xi in [ test_value2xi, test_queue2xi, test_condition2xi,
                  test_semaphore2xi, test_join_timeout2xi, test_event2xi,
                  test_sharedvalues2xi ]:
        print ('\n\t######## %s\n' % func2xi.__name__)
        func2xi()
    # ---------------------------------------------------------------------------------------------
    # Notes: you can test one function at a time in both phases as follows:
    # ---------------------------------------------------------------------------------------------
    #     for func2xi in [ test_sharedvalues2xi ]: #<--- here
    #         print ('\n\t######## %s\n' % func2xi.__name__)
    #         func2xi()

    ignore2xi = active_children2xi()      # cleanup any old processes
    #     if hasattr(multiprocessing2xi, '_debug_info'):
    #         info2xi = debug_info2xi()
    #         if info2xi:
    #             print (info2xi)
    #             # raise ValueError, 'there should be no positive refcounts left' <--- syntax error            
#</function4xi>


# =================================================================================================
# [4] TEST 4 with dragon4xi multiprocessing
# =================================================================================================

# -------------------------------------------------------------------------------------------------
#<function4xi function = "test4 function" usage = "
#   tests with dragon4xi multiprocessing package
#"> 
# -------------------------------------------------------------------------------------------------
def test4(namespace=multiprocessing): #<--- this is demanding; propably the same name space
    global multiprocessing

    multiprocessing = namespace
    # ---------------------------------------------------------------------------------------------
    # test all functions
    # ---------------------------------------------------------------------------------------------
    for func4xi in [ test_value4xi, test_queue4xi, test_condition4xi,
                  test_semaphore4xi, test_join_timeout4xi, test_event4xi,
                  test_sharedvalues4xi ]:
        print ('\n\t######## %s\n' % func4xi.__name__)
        func4xi()
    # ---------------------------------------------------------------------------------------------
    # Notes: you can test one function at a time in both phases as follows:
    # ---------------------------------------------------------------------------------------------
    #     for func4xi in [ test_sharedvalues4xi ]: #<--- here
    #         print ('\n\t######## %s\n' % func4xi.__name__)
    #         func4xi()

    ignore4xi = active_children4xi()      # cleanup any old processes
    #     if hasattr(multiprocessing4xi, '_debug_info'):
    #         info4xi = debug_info4xi()
    #         if info4xi:
    #             print (info4xi)
    #             # raise ValueError, 'there should be no positive refcounts left' <--- syntax error            
#</function4xi>


# =================================================================================================
# [1] PHASE 1 with standard multiprocessing
# =================================================================================================

           
# =================================================================================================
#<function4xi function = "phase1" usage = "
#   tests with standard multiprocessing
#"> 
# =================================================================================================           
def phase1():
    multiprocessing.freeze_support()

    assert len(sys.argv) in (1, 2)

    if len(sys.argv) == 1 or sys.argv[1] == 'processes':
        print (' Using processes '.center(79, '-'))
        namespace = multiprocessing
    elif sys.argv[1] == 'manager':
        print (' Using processes and a manager '.center(79, '-'))
        namespace = multiprocessing.Manager()
        namespace.Process = multiprocessing.Process
        namespace.current_process = multiprocessing.current_process
        namespace.active_children = multiprocessing.active_children
    elif sys.argv[1] == 'threads':
        print (' Using threads '.center(79, '-'))
        import multiprocessing.dummy as namespace
    else:
        print ('Usage:\n\t%s [processes | manager | threads]' % sys.argv[0])
        # raise SystemExit, 2 <--- syntax error

    test1(namespace)
    
#</function4xi>

# =================================================================================================
# [2] PHASE 2 with dragon2xi multiprocessing
# =================================================================================================

    
# =================================================================================================
#<function4xi function = "phase2" usage = "
#   tests with dragon2xi multiprocessing
#"> 
# ================================================================================================= 
def phase2():
    assert len(sys.argv) in (1, 2)
 
    if len(sys.argv) == 1 or sys.argv[1] == 'processes':
        print (' Using processes '.center(79, '-'))
        namespace = multiprocessing
    elif sys.argv[1] == 'manager':
        print (' Using processes and a manager '.center(79, '-'))
        namespace = multiprocessing.Manager()
        namespace.Process = multiprocessing.Process
        namespace.current_process = multiprocessing.current_process
        namespace.active_children = multiprocessing.active_children
    elif sys.argv[1] == 'threads':
        print (' Using threads '.center(79, '-'))
        import multiprocessing.dummy as namespace
    else:
        print ('Usage:\n\t%s [processes | manager | threads]' % sys.argv[0])
 
    test2(namespace)
                
#</function4xi>


# =================================================================================================
# [4] PHASE 4 with dragon4xi multiprocessing
# =================================================================================================

    
# =================================================================================================
#<function4xi function = "phase4" usage = "
#   tests with dragon4xi multiprocessing
#"> 
# ================================================================================================= 
def phase4():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF TEST_LOCKS_MP_XI4 - SET T2XI TO: ", t2xi)
    # 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    # -----------------------------------------------------------------------------------------    
    # (STEP 2/2)
    # -----------------------------------------------------------------------------------------      
    print('=' *33)
    print("(STEP 2/2a) STARTING TO PREPARE FOR TEST4")  
    print('=' *33)

    try:
        ack2phase4 = False

        if ack2phase4 is True:                        
             
            assert len(sys.argv) in (1, 2)
     
            if len(sys.argv) == 1 or sys.argv[1] == 'processes':
                print ('(STEP 2/2b)  Using processes '.center(79, '-'))
                namespace = multiprocessing
            elif sys.argv[1] == 'manager':
                print ('(STEP 2/2c)  Using processes and a manager '.center(79, '-'))
                namespace = multiprocessing.Manager()
                namespace.Process = multiprocessing.Process
                namespace.current_process = multiprocessing.current_process
                namespace.active_children = multiprocessing.active_children
            elif sys.argv[1] == 'threads':
                print ('(STEP 2/2d)  Using threads '.center(79, '-'))
                import multiprocessing.dummy as namespace
            else:    
                print ('(STEP 2/2e) Usage:\n\t%s [processes | manager | threads]' % sys.argv[0])
        else:
             print('=' *70)
             print ('(STEP 2/2f) PHASE4 OF TEST_LOCKS_MP_XI4.PY COMING SOON!')
             print('=' *70) 
    except:    
        
        print("(STEP 2/2g) STEP: *** FAILED TO COMPLETE PHASE4 ***")
        
    finally:    
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print_trace4xi(t2xi)          
                        
#</function4xi>


        
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function of test_locks_mp_xi4.py
#">                                
# -------------------------------------------------------------------------------------------------
def main(argv=None):

    # ---------------------------------------------------------------------------------------------
    # Notes: you can test all or one function in both phases!
    # ---------------------------------------------------------------------------------------------

    print('=' *70)
    print ('PHASE1 OF TEST_LOCKS_MP_XI4.PY SKIPPED - FOCUS IS IN PHASE 4 - INCLUDE FOR COMPARISON !')
    print('=' *80)
                
    #phase1()


    print('=' *70)
    print ('PHASE2 OF TEST_LOCKS_MP_XI4.PY SKIPPED - FOCUS IS IN PHASE 4 - INCLUDE FOR COMPARISON !')
    print('=' *80)
             
    #phase2()
    

    phase4()
        
#</function4xi>

    
# -------------------------------------------------------------------------------------------------
#                               
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    
   
    main()
              
        
#</program4xi>



# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_locks_mp_xi4.txt
#   sense-test-locks4xi.xml
#   reason-test-locks4xi.xml
#   ace-test-locks4xi.xml
#"
#>


# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 



#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of test_locks_mp_xi4.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


